/*************************************************************************\
*   				Xcard 1.2				  *
*									  *
* Copyright 1991, Kenneth C. Nelson			 	          *
*									  *
* Rights       : I, Ken Nelson own Xcard.  You may compile, modify, and   *
*                use Xcard.  You may not sell Xcard or anything derived   *
*		 from Xcard in binary or source for more than reasonable  *
*                media costs.                                             *
*                                                                         *
*		 Xcard uses a dynamic object library	   	          *
*		 that I don't own.  See the subdirectory dynobj for  	  *
*		 restrictions on its use.				  *
*								          *
*                Please feel free to modify Xcard. See Todo for details.  *
*									  *
\*************************************************************************/


/*
 *
 * xui.c  - provides X Windows interface for XCard.
 *	    Includes routines used to build up the total interface
 *	    by adding the components.
 *
*/



#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#ifdef XAW_NOT_NESTED
#  include <X11/Paned.h>
#else
#  include <X11/Xaw/Paned.h>
#endif Athena Widgets not nested under /usr/include/X11

#include "cards.h"
#include "xcard.icon"

#include "editbody.h"
#include "xmsg.h"


 /*
  * the Widgets used to build up the XCard interface.
  * that is widgets that need to be know globally.
  *
 */


Widget toplevel;



/*
 * Syntax() - outputs the command line interface usage string and then exits.
 *
 */
 
void  Syntax(call)
  char *call;
{
  printf("Usage: %s -toolkit_option cardfile\n\n");
}



void addXCardIcon()
{
  Pixmap icon_pixmap;

  icon_pixmap = XCreateBitmapFromData(XtDisplay(toplevel),
				      RootWindowOfScreen(XtScreen(toplevel)),
				      xcard_bits,
				      xcard_width,
				      xcard_height
				     );

  XtVaSetValues(toplevel,XtNiconPixmap,icon_pixmap,NULL);
				    
}

 
/*
 * setTitleBar() - sets the title bar for XCard to the provided text.
 *		   the text is Centered.
 *
 */

void setTitleBar(title)
	char *title;
{
   XtVaSetValues(toplevel,XtNlabel,title,NULL);
}





/*
 * initXpegInterface() - parses the command line for xtoolkit options,
 *                       and then makes a toplevel shell.
 */

void initXCardInterface(argc,argv)
 int     *argc;
 char    **argv;
{


  toplevel = XtInitialize(
	                   argv[0],
		           (char *)xcard_version(),
		           NULL,
		           0,
		           argc,
			   argv
			 );

}
      



/*
 * buildXCardInterface() - uses all the above routines to build up the
 *			   XCard X interface.
 *			   returns the topleve Wigdget of the whole deal.
 *
 */


Widget buildXCardInterface(argc,argv)
 int argc;
 char **argv;
{
  void addMenuArea(), addCardHeaderListArea();
  Widget pane,pane2;

    addXCardIcon();
    pane = XtVaCreateManagedWidget(
				   "bigPane",
				   panedWidgetClass,
				   toplevel,
				   XtNwidth,563,
				   NULL
				  );
    addCardHeaderListArea(pane);
    pane2 = XtVaCreateManagedWidget(
				   "subPane",
				   panedWidgetClass,
				   pane,
				   XtNshowGrip,TRUE,
				   XtNwidth,563,
				   NULL
				  );
    XawPanedAllowResize(pane2,TRUE);
    addMenuArea(pane2); 
    addCardTextEditor(pane2);

    updateCardHeaderList();
    setCurrentCard(FIRSTCARD);
    setHeaderArea(headerCurrentCard());
    setCardEditorText(bodyCurrentCard());

    addSearchPopup(pane);
    addMessagePopups(pane);
    buildPopupEditor(pane);
    
}



void runXCardInterface()
{
  XtRealizeWidget(toplevel);
  XtMainLoop();
}

